<template>
  <div>
    <Header :loggedIn="loggedIn" :auth="auth">
      <h1 class="header--hero--title">{{ article && article.title }}</h1>
    </Header>
    <Container v-if="loading">
      <div>loading ...</div>
    </Container>
    <Container v-else-if="article">
      <article class="article--body">
        {{ article && article.body }}
      </article>
      <ul v-if="!gettingComments" class="comments-list">
        <li class="comments-list--comment" v-for="comment in comments" :key="comment.id">
          <Comment :comment="comment" />
        </li>
      </ul>
      <div v-if="gettingComments" style="text-align: left;">Getting Comments ...</div>
      <CommentForm v-model="commentBody" :submitting="submittingComment" :error="commentError" :success="commentSuccess" @submit="commentSubmit" @change="commentError = ''; commentSuccess = ''"/>
    </Container>
  </div>
</template>

<script>
import Header from '../components/Header';
import Container from '../components/Container';
import CommentForm from '../components/CommentForm';
import AC_Blog from '../lib/blog';
import Comment from '../components/Comment';

let blog = new AC_Blog();

export default {
  name: 'blog-single',
  components: {
    Container,
    Header,
    CommentForm,
    Comment
  },
  props: ['auth'],
  data: function(){
      return {
          slug: this.$route.params.slug,
          article: undefined,
          loading: false,
          gettingComments: false,
          loggedIn: (this.auth.currentUser ? true : false),
          commentBody: '',
          submittingComment: false,
          commentError: '',
          commentSuccess: '',
          comments: []
      };
  },
  methods: {
    commentSubmit: function(){
      if(!this.commentBody){
        this.commentError = 'Please enter your comment.';
        this.commentError = '';
        this.commentSuccess = '';
      } else if(this.article && this.article.slug) {
        this.submittingComment = true;
        let comment = {
          body: this.commentBody
        }
        blog.submitComment(this.article.slug, comment)
        .then((result) => {
          this.submittingComment = false;
          this.commentBody = '';
          this.commentSuccess = 'Comment sent!';
          this.comments.unshift(result);
        })
        .catch((err) => {
          this.submittingComment = false;
          if(err.status == 401){
            this.commentError = 'You should be logged in to send comment!';
          } else {
            this.commentError = 'Something happened. comment was not sent!';
          }
        });
      }
    }
  },
  mounted: function(){
    this.loading = true;
    this.gettingComments = true;
    blog.getArticle(this.slug)
    .then((article) => {
      this.loading = false;
      this.article = article;
    })
    .catch((err) => {
      this.loading = false;
      if(err.status == 404){
        // redirect to not found page
      }
    });

    blog.getArticleComments(this.slug)
    .then((comments) => {
      this.gettingComments = false;
      this.comments = comments;
    })
    .catch((err) => {
      this.gettingComments = false;
      // show errors or try again or ignore them. do whatever you want.
    });
  }
}
</script>

<style>
.article--body {
  text-align: left;
  margin-bottom: 100px;
  font-size: 16px;
  font-weight: normal;
  line-height: 28px;
  color: #4e5c66;
}

.comments-list {
  list-style: none;
  padding: 0;
  margin: 0;
  margin-bottom: 80px;
  max-width: 800px;
}

.comments-list--comment {
  margin-bottom: 40px;
}

</style>
